API reference

Refunds

Refund objects allow you to refund a previously created charge that isn't refunded yet. Funds are refunded to the credit or debit card that's initially charged. Related guide: Refunds

Knox answers these operations with the same requests and responses as Stripe's API. Authenticate with your secret key, Authorization: Bearer sk_test_..., from your server, and send form-encoded bodies. Test mode only: live processing is currently disabled.

Create a refund

POST/v1/refunds

When you create a new refund, you must specify a Charge or a PaymentIntent object on which to create it. Creating a new refund will refund a charge that has previously been created but not yet refunded. Funds will be refunded to the credit or debit card that was originally charged. You can optionally refund only part of a charge. You can do so multiple times, until the entire charge has been refunded. Once entirely refunded, a charge can’t be refunded again. This method will raise an error when called on an already-refunded charge, or when trying to refund more money than is left on a charge.

Body parameters

  • amountinteger
  • chargestring

    The identifier of the charge to refund.

  • currencystring

    Three-letter ISO currency code, in lowercase. Must be a supported currency.

  • customerstring

    Customer whose customer balance to refund from.

  • expandarray of strings

    Specifies which fields in the response should be expanded.

  • instructions_emailstring

    For payment methods without native refund support (e.g., Konbini, PromptPay), use this email from the customer to receive refund instructions.

  • metadataobject

    Set of key-value pairs that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to metadata.

  • originstring

    Origin of the refund

    Possible values
    • customer_balance
  • payment_intentstring

    The identifier of the PaymentIntent to refund.

  • reasonstring

    String indicating the reason for the refund. If set, possible values are duplicate, fraudulent, and requested_by_customer. If you believe the charge to be fraudulent, specifying fraudulent as the reason will add the associated card and email to your block lists, and will also help us improve our fraud detection algorithms.

    Possible values
    • duplicate
    • fraudulent
    • requested_by_customer
  • refund_application_feeboolean

    Boolean indicating whether the application fee should be refunded when refunding this charge. If a full charge refund is given, the full application fee will be refunded. Otherwise, the application fee will be refunded in an amount proportional to the amount of the charge refunded. An application fee can be refunded only by the application that created the charge.

  • reverse_transferboolean

    Boolean indicating whether the transfer should be reversed when refunding this charge. The transfer will be reversed proportionally to the amount being refunded (either the entire or partial amount).A transfer can be reversed only by the application that created the charge.

Returns

The refund object.

POST /v1/refunds
curl -X POST https://api.knoxapi.com/v1/refunds \
  -H "Authorization: Bearer $KNOX_SECRET_KEY"
Response
{
  "amount": 100,
  "balance_transaction": null,
  "charge": "ch_1PgafuB7WZ01zgkWXYmPNZs8",
  "created": 1234567890,
  "currency": "usd",
  "destination_details": {
    "card": {
      "type": "reversal"
    },
    "type": "card"
  },
  "id": "re_1Pgc72B7WZ01zgkWqPvrRrPE",
  "metadata": {},
  "object": "refund",
  "payment_intent": null,
  "reason": null,
  "receipt_number": null,
  "source_transfer_reversal": null,
  "status": "succeeded",
  "transfer_reversal": null,
  "customer": null,
  "customer_account": null,
  "payment_method": null
}

List all refunds

GET/v1/refunds

Returns a list of all refunds you created. We return the refunds in sorted order, with the most recent refunds appearing first. The 10 most recent refunds are always available by default on the Charge object.

Query parameters

  • chargestring

    Only return refunds for the charge specified by this charge ID.

  • createdobject | integer

    Only return refunds that were created during the given date interval.

    Show 4 child parameters
    • gtinteger
    • gteinteger
    • ltinteger
    • lteinteger
  • ending_beforestring

    A cursor for use in pagination. ending_before is an object ID that defines your place in the list. For instance, if you make a list request and receive 100 objects, starting with obj_bar, your subsequent call can include ending_before=obj_bar in order to fetch the previous page of the list.

  • expandarray of strings

    Specifies which fields in the response should be expanded.

  • limitinteger

    A limit on the number of objects to be returned. Limit can range between 1 and 100, and the default is 10.

  • payment_intentstring

    Only return refunds for the PaymentIntent specified by this ID.

  • starting_afterstring

    A cursor for use in pagination. starting_after is an object ID that defines your place in the list. For instance, if you make a list request and receive 100 objects, ending with obj_foo, your subsequent call can include starting_after=obj_foo in order to fetch the next page of the list.

Returns

A list of refund objects.

GET /v1/refunds
curl -G https://api.knoxapi.com/v1/refunds \
  -H "Authorization: Bearer $KNOX_SECRET_KEY" \
  --data-urlencode limit=3
Response
{
  "object": "list",
  "url": "/v1/refunds",
  "has_more": false,
  "data": [
    {
      "amount": 100,
      "balance_transaction": null,
      "charge": "ch_1PgafuB7WZ01zgkWXYmPNZs8",
      "created": 1234567890,
      "currency": "usd",
      "destination_details": {
        "card": {
          "type": "reversal"
        },
        "type": "card"
      },
      "id": "re_1Pgc72B7WZ01zgkWqPvrRrPE",
      "metadata": {},
      "object": "refund",
      "payment_intent": null,
      "reason": null,
      "receipt_number": null,
      "source_transfer_reversal": null,
      "status": "succeeded",
      "transfer_reversal": null,
      "customer": null,
      "customer_account": null,
      "payment_method": null
    }
  ]
}

Update a refund

POST/v1/refunds/{refund}

Updates the refund that you specify by setting the values of the passed parameters. Any parameters that you don’t provide remain unchanged. This request only accepts metadata as an argument.

Path parameters

  • refundstringRequired

Body parameters

  • expandarray of strings

    Specifies which fields in the response should be expanded.

  • metadataobject

    Set of key-value pairs that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to metadata.

Returns

The refund object.

POST /v1/refunds/{refund}
curl https://api.knoxapi.com/v1/refunds/re_1Pgc72B7WZ01zgkWqPvrRrPE \
  -H "Authorization: Bearer $KNOX_SECRET_KEY" \
  -d "metadata[order_id]=6735"
Response
{
  "amount": 100,
  "balance_transaction": null,
  "charge": "ch_1PgafuB7WZ01zgkWXYmPNZs8",
  "created": 1234567890,
  "currency": "usd",
  "destination_details": {
    "card": {
      "type": "reversal"
    },
    "type": "card"
  },
  "id": "re_1Pgc72B7WZ01zgkWqPvrRrPE",
  "metadata": {},
  "object": "refund",
  "payment_intent": null,
  "reason": null,
  "receipt_number": null,
  "source_transfer_reversal": null,
  "status": "succeeded",
  "transfer_reversal": null,
  "customer": null,
  "customer_account": null,
  "payment_method": null
}

Retrieve a refund

GET/v1/refunds/{refund}

Retrieves the details of an existing refund.

Path parameters

  • refundstringRequired

Query parameters

  • expandarray of strings

    Specifies which fields in the response should be expanded.

Returns

The refund object.

GET /v1/refunds/{refund}
curl https://api.knoxapi.com/v1/refunds/re_1Pgc72B7WZ01zgkWqPvrRrPE \
  -H "Authorization: Bearer $KNOX_SECRET_KEY"
Response
{
  "amount": 100,
  "balance_transaction": null,
  "charge": "ch_1PgafuB7WZ01zgkWXYmPNZs8",
  "created": 1234567890,
  "currency": "usd",
  "destination_details": {
    "card": {
      "type": "reversal"
    },
    "type": "card"
  },
  "id": "re_1Pgc72B7WZ01zgkWqPvrRrPE",
  "metadata": {},
  "object": "refund",
  "payment_intent": null,
  "reason": null,
  "receipt_number": null,
  "source_transfer_reversal": null,
  "status": "succeeded",
  "transfer_reversal": null,
  "customer": null,
  "customer_account": null,
  "payment_method": null
}

Cancel a refund

POST/v1/refunds/{refund}/cancel

Cancels a refund with a status of requires_action. You can’t cancel refunds in other states. Only refunds for payment methods that require customer action can enter the requires_action state.

Path parameters

  • refundstringRequired

Body parameters

  • expandarray of strings

    Specifies which fields in the response should be expanded.

Returns

The refund object.

POST /v1/refunds/{refund}/cancel
curl -X POST https://api.knoxapi.com/v1/refunds/re_1Pgc72B7WZ01zgkWqPvrRrPE/cancel \
  -H "Authorization: Bearer $KNOX_SECRET_KEY"
Response
{
  "amount": 100,
  "balance_transaction": null,
  "charge": "ch_1PgafuB7WZ01zgkWXYmPNZs8",
  "created": 1234567890,
  "currency": "usd",
  "destination_details": {
    "card": {
      "type": "reversal"
    },
    "type": "card"
  },
  "id": "re_1Pgc72B7WZ01zgkWqPvrRrPE",
  "metadata": {},
  "object": "refund",
  "payment_intent": null,
  "reason": null,
  "receipt_number": null,
  "source_transfer_reversal": null,
  "status": "succeeded",
  "transfer_reversal": null,
  "customer": null,
  "customer_account": null,
  "payment_method": null
}

Operations and schemas come from the pinned Stripe OpenAPI specification (MIT); response examples from its fixtures. Nested object definitions and enums are in the complete specification.